nem.featureselection <- function(D,inference="nem.greedy",models=NULL,type="mLL",para=NULL,hyperpara=NULL,Pe=NULL,Pm=NULL,Pmlocal=NULL,local.prior.size=length(unique(colnames(D))),local.prior.bias=1,triples.thrsh=0.5,lambda=0,trans.close=TRUE,verbose=TRUE, tol=1e-4){
	
	if(type %in% c("CONTmLLRatio","CONTmLLMAP")){
		Sgenes = unique(colnames(D))
		nrS = length(Sgenes)
		 if (is.null(Pe)){ 	
			Pe <- matrix(1/nrS,nrow=nrow(D),ncol=nrS)
			colnames(Pe) <- Sgenes  		
  		}    		
		deltaseq = 0:10
		results = sapply(deltaseq, function(d){			
			net = nem(D, inference, models, type, para, hyperpara, Pe, Pm, Pmlocal, local.prior.size, local.prior.bias, triples.thrsh, lambda, delta=d, trans.close=trans.close, selEGenes=FALSE,verbose=verbose)	
			if(verbose){
				cat(length(net$selected), " selected E-genes (delta = ", d, ", BIC = ", -2*net$mLL + log(nrow(D))*length(net$selected), "):", sort(net$selected)[1:min(20, length(net$selected))]," ...\n")				
			}			
			net
		})		
 		s = -2*unlist(results["mLL",]) + log(nrow(D))*sapply(results["selected",], length) # BIC model selection
# 		s = -unlist(results["mLL",])/sapply(results["selected",], length) # Achim's original approach		
 		winner = which.min(s)				
		net = results[,winner]	
		class(net) = inference
	}
	else{
		converged = FALSE
		while(!converged){
			net = nem(D, inference, models, type, para, hyperpara, Pe, Pm, Pmlocal, local.prior.size, local.prior.bias, triples.thrsh, lambda, selEGenes=FALSE,verbose=verbose)			
			sel = getRelevantEGenes(as(net$graph,"matrix"), D, para, hyperpara, Pe, Pm, lambda, delta=1e-10, type=type)			
			if(verbose)
				cat("Old Likelihood = ", net$mLL, "new likelihood = ", sel$mLL, "\n", length(sel$selected), " selected E-genes:", sort(sel$selected)[1:min(20, length(sel$selected))]," ...\n")			
			converged = (abs(max(net$mLL) - max(sel$mLL))/abs(max(net$mLL)) < tol)
			if(converged)
				break
			D = D[sel$selected,]
		}
		net$selected = sel$selected
		net$mLL = sel$mLL		
	}
	if(verbose)
		cat("Converged! ", length(net$selected),"selected E-genes\n")
	net
}
